diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/prompt.c tin-2.6.5/src/prompt.c
--- tin-2.6.4/src/prompt.c	2024-12-02 22:44:33.000000000 +0100
+++ tin-2.6.5/src/prompt.c	2025-12-17 08:19:36.795467933 +0100
@@ -3,10 +3,10 @@
  *  Module    : prompt.c
  *  Author    : I. Lea
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-02
+ *  Updated   : 2025-12-17
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -53,7 +53,11 @@ static char *prompt_yn_choice;
 /*
  * Local prototypes
  */
-static int prompt_list(int row, int col, int var, constext *help_text, constext *prompt_text, constext *list[], int size);
+static int prompt_list(int row, int col, int *var, constext *help_text, constext *prompt_text, constext * const list[], int size);
+#ifdef HAVE_COLOR
+	static void show_color_help(void);
+	static void clear_color_help(void);
+#endif /* HAVE_COLOR */
 
 /*
  *  prompt_num
@@ -73,7 +77,7 @@ prompt_num(
 	snprintf(tmp, sizeof(tmp), "%c", ch);
 	if ((p = tin_getline(prompt, 1, tmp, 0, FALSE, HIST_OTHER)) != NULL) {
 		STRCPY(tmp, p);
-		num = atoi(tmp);
+		num = strtol(tmp, NULL, 10);
 	} else
 		num = -1;
 
@@ -160,6 +164,9 @@ prompt_menu_string(
  * last line giving the default answer "default_answer".
  * The function returns 1 if the user decided "yes", -1 if the user wanted
  * to escape, or 0 for any other decision.
+ *
+ * TODO: add nl_langinfo(YESEXPR) / nl_langinfo(NOEXPR), but use pcre
+ *       instead of rpmatch()
  */
 int
 prompt_yn(
@@ -244,7 +251,11 @@ prompt_yn(
 			default:
 				break;
 		}
+#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 		func = key_to_func((wchar_t) ch, prompt_keys);
+#else
+		func = key_to_func(ch, prompt_keys);
+#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 	} while (func == NOT_ASSIGNED);
 
 	input_context = cNone;
@@ -290,6 +301,92 @@ prompt_yn_redraw(
 }
 
 
+#ifdef HAVE_COLOR
+static void
+show_color_help(
+	void)
+{
+	char *buf;
+	int i, row, col, head, tail, len, col_width = cCOLS / 6;
+	int col_normal_orig = tinrc.col_normal;
+	int col_back_orig = tinrc.col_back;
+
+	clear_color_help();
+	for (row = 2, col = 0; row >= 0; row--, col += 6) {
+		MoveCursor(cLINES - row, 0);
+		for (i = col; i <= col + 5 && txt_colors[i]; i++) {
+			if (i == 0)
+				fcol(-1);
+			else if (i < 6)
+				fcol(15);
+			else
+				fcol(0);
+			bcol(i - 1);
+			len = strwidth(_(txt_colors[i]));
+			if (col_width > len) {
+				head = (col_width - len) / 2;
+				tail = col_width - len - head;
+				if (tail > 1 || (head == 1 && tail == 1))
+					/*
+					 * we cannot use %-*s for color names, because names
+					 * with multibyte chars would destroy the layout
+					 */
+					my_printf("%*c%s%*c", head, ' ', _(txt_colors[i]), tail, ' ');
+				else
+					my_printf("%s ", _(txt_colors[i]));
+			} else {
+				buf = strunc(_(txt_colors[i]), col_width);
+				my_printf("%s", buf);
+				free(buf);
+			}
+		}
+		bcol(col_back_orig);
+	}
+	fcol(col_normal_orig);
+}
+
+
+static void
+clear_color_help(
+	void)
+{
+	MoveCursor(cLINES - 2, 0);
+	CleartoEOS();
+}
+#endif /* HAVE_COLOR */
+
+
+#ifdef HAVE_COLOR
+#	define SET_OPT_COLOR() do { \
+		if (var == &tinrc.col_invers_bg || var == &tinrc.col_invers_fg) { \
+			int orig_var = *var; \
+			*var = idx - adjust; \
+			StartInverse(); \
+			*var = orig_var; \
+		} else if (var == &tinrc.col_back) \
+			bcol(idx - adjust); \
+		else \
+			fcol(idx - adjust); \
+	} while (0)
+
+#	define RESET_OPT_COLOR() do { \
+		if (var != &tinrc.col_back) \
+			bcol(old_bcol); \
+		if (var != &tinrc.col_normal) \
+			fcol(old_fcol); \
+		if (var == &tinrc.col_invers_bg || var == &tinrc.col_invers_fg) \
+			EndInverse(); \
+	} while (0)
+
+#	define RESTORE_OPT_COLOR() do { \
+		if (var == &tinrc.col_back) \
+			bcol(old_bcol); \
+		else if (var == &tinrc.col_normal) \
+			fcol(old_fcol); \
+		else if (var == &tinrc.col_invers_bg || var == &tinrc.col_invers_fg) \
+			EndInverse(); \
+	} while (0)
+#endif /* HAVE_COLOR */
 /*
  * help_text is displayed near the bottom of the screen.
  * var is an index into a list containing size elements.
@@ -302,22 +399,25 @@ static int
 prompt_list(
 	int row,
 	int col,
-	int var,
+	int *var,
 	constext *help_text,
 	constext *prompt_text,
-	constext *list[],
+	constext * const list[],
 	int size)
 {
-	int ch, var_orig;
-	int i, offset, width = 0;
-	int change;
+	int ch, change, i, idx, offset, width = 0;
 	int adjust = (strcasecmp(_(list[0]), _(txt_default)) == 0);
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	char *buf;
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+#ifdef HAVE_COLOR
+	/* initialization to silence compiler warnings */
+	t_bool color_opt = use_color && (list == txt_colors || list == txt_backcolors);
+	int old_bcol = tinrc.col_back;
+	int old_fcol = tinrc.col_normal;
+#endif /* HAVE_COLOR */
 
-	var += adjust;
-	var_orig = var;
+	idx = *var + adjust;
 
 	/*
 	 * Find the length of longest printable text
@@ -325,7 +425,13 @@ prompt_list(
 	for (i = 0; i < size; i++)
 		width = MAX(width, strwidth(_(list[i])));
 
-	show_menu_help(help_text);
+#ifdef HAVE_COLOR
+	if (color_opt) {
+		(void) help_text;
+		show_color_help();
+	} else
+#endif /* HAVE_COLOR */
+		show_menu_help(help_text);
 	cursoron();
 
 	offset = strwidth(_(prompt_text));
@@ -336,10 +442,35 @@ prompt_list(
 	if (offset + width >= cCOLS)
 		width = cCOLS - offset - 1;
 
+#ifdef HAVE_COLOR
+	if (color_opt) {
+		MoveCursor(row, col + offset);
+		SET_OPT_COLOR();
+#	if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+		if ((buf = spart(_(list[idx]), width, TRUE)) != NULL) {
+			my_printf("%s", buf);
+			free(buf);
+		} else
+#	endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+			my_printf("%-*s", width, _(list[idx]));
+		RESET_OPT_COLOR();
+		my_flush();
+	}
+#	endif /* HAVE_COLOR */
+
+	input_context = cPromptList;
+
 	do {
 		MoveCursor(row, col + offset);
 		ch = (char) ReadCh();
 
+#ifdef USE_CURSES
+		if (pending_sactions && ch != EOF) {
+/*			ungetch('\r'); */ /* reenter option, would differ from !USE_CURSES */
+			ungetch(ESC);
+		}
+#endif /* USE_CURSES */
+
 		/*
 		 * change:
 		 *   1 = move to the next list element
@@ -380,42 +511,69 @@ prompt_list(
 				break;
 		}
 
-		if (change) {
+		if (change && !pending_sactions) {
 			/*
 			 * increment or decrement list, loop around at the limits
 			 */
-			var += change;
-			if (var < 0)
-				var = size - 1;
-			else
-				var %= (size ? size : 1);
-
+			do {
+				idx += change;
+				if (idx < 0)
+					idx = size - 1;
+				else
+					idx %= (size ? size : 1);
+			} while (!*list[idx]); /* allow gaps in lists */
+
+#	ifdef HAVE_COLOR
+			if (color_opt)
+				SET_OPT_COLOR();
+#	endif /* HAVE_COLOR */
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-			if ((buf = spart(_(list[var]), width, TRUE)) != NULL) {
+			if ((buf = spart(_(list[idx]), width, TRUE)) != NULL) {
 				my_printf("%s", buf);
 				free(buf);
 			} else
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-				my_printf("%-*s", width, _(list[var]));
+				my_printf("%-*s", width, _(list[idx]));
+#	ifdef HAVE_COLOR
+			if (color_opt)
+				RESET_OPT_COLOR();
+#	endif /* HAVE_COLOR */
 			my_flush();
 		}
-	} while (ch != '\r' && ch != '\n' && ch != ESC);
+	} while (ch != '\r' && ch != '\n' && ch != ESC && !pending_sactions);
 
-	if (ch == ESC) {
-		var = var_orig;
+	input_context = cNone;
+
+	if (ch == ESC || pending_sactions) {
+		pending_sactions = 0;
+#	ifdef HAVE_COLOR
+		if (color_opt)
+			RESTORE_OPT_COLOR();
+#	endif /* HAVE_COLOR */
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
-		if ((buf = spart(_(list[var]), width, TRUE)) != NULL) {
+		if ((buf = spart(_(list[*var]), width, TRUE)) != NULL) {
 			my_printf("%s", buf);
 			free(buf);
 		} else
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
-			my_printf("%-*s", width, _(list[var]));
+			my_printf("%-*s", width, _(list[*var]));
 		my_flush();
-	}
+	} else
+		*var = idx - adjust;
+
+#ifdef HAVE_COLOR
+	if (color_opt)
+		clear_color_help();
+#endif /* HAVE_COLOR */
 
 	cursoroff();
-	return (var - adjust);
+	return *var;
 }
+#ifdef HAVE_COLOR
+#	undef SET_OPT_COLOR
+#	undef RESET_OPT_COLOR
+#	undef RESTORE_OPT_COLOR
+#endif /* HAVE_COLOR */
 
 
 /*
@@ -431,7 +589,7 @@ prompt_option_on_off(
 	t_bool old_value = *variable;
 
 	fmt_option_prompt(prompt, sizeof(prompt), TRUE, option);
-	*variable = prompt_list(option_row(option), 0, (int) *variable, option_table[option].txt->help, prompt, txt_onoff, 2) ? TRUE : FALSE;
+	*variable = prompt_list(option_row(option), 0, (int *) variable, option_table[option].txt->help, prompt, txt_onoff, 2) ? TRUE : FALSE;
 	return bool_not(bool_equal(*variable, old_value));
 }
 
@@ -451,7 +609,7 @@ prompt_option_list(
 	while (option_table[option].opt_list[opt_count] != NULL)
 		++opt_count;
 	fmt_option_prompt(prompt, sizeof(prompt), TRUE, option);
-	*variable = prompt_list(option_row(option), 0, *variable, option_table[option].txt->help, prompt, option_table[option].opt_list, opt_count);
+	*variable = prompt_list(option_row(option), 0, variable, option_table[option].txt->help, prompt, option_table[option].opt_list, opt_count);
 	return *variable != old_value;
 }
 
@@ -487,10 +645,12 @@ prompt_option_string(
 		is_same = strcmp(old_value, variable) ? TRUE : FALSE;
 		free(old_value);
 		free(variable);
+		cursoroff();
 		return is_same;
 	} else {
 		free(old_value);
 		free(variable);
+		cursoroff();
 		return FALSE;
 	}
 }
@@ -518,13 +678,20 @@ prompt_option_num(
 	fmt_option_prompt(prompt, sizeof(prompt) - 1, TRUE, option);
 	snprintf(&number[0], sizeof(number), "%d", *(option_table[option].variable));
 
-	if ((p = tin_getline(prompt, 2, number, 0, FALSE, HIST_OTHER)) == NULL)
+	if ((p = tin_getline(prompt, 2, number, 0, FALSE, HIST_OTHER)) == NULL) {
+		cursoroff();
 		return FALSE;
+	}
 
 	STRCPY(number, p);
-	num = atoi(number);
+	num = s2i(number, INT_MIN, INT_MAX);
+	/*
+	 * we don't check errno here as
+	 * - EINVAL shouldn't happen as it is already caught by tin_getline()
+	 * - ERANGE the default behaviour of s2i() is fine here
+	 */
 	*(option_table[option].variable) = num;
-	clear_message();
+	cursoroff();
 	return TRUE;
 }
 
@@ -563,18 +730,18 @@ prompt_option_char(
 	if ((curr_val = wchar_t2char(input))) {
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
-	do {
-		show_menu_help(option_table[option].txt->help);
-		MoveCursor(option_row(option), 0);
-		fmt_option_prompt(prompt, sizeof(prompt) - 1, TRUE, option);
-
-		if ((p = tin_getline(prompt, 0, curr_val, max_chars, FALSE, HIST_OTHER)) == NULL) {
-			clear_message();
-			return FALSE;
-		}
-		if (!*p)
-			info_message(_(txt_info_enter_valid_character));
-	} while (!*p);
+		do {
+			show_menu_help(option_table[option].txt->help);
+			MoveCursor(option_row(option), 0);
+			fmt_option_prompt(prompt, sizeof(prompt) - 1, TRUE, option);
+
+			if ((p = tin_getline(prompt, 0, curr_val, max_chars, FALSE, HIST_OTHER)) == NULL) {
+				clear_message();
+				return FALSE;
+			}
+			if (!*p)
+				info_message(_(txt_info_enter_valid_character));
+		} while (!*p);
 
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 		if ((wp = char2wchar_t(p))) {
@@ -643,7 +810,7 @@ prompt_string_ptr_default(
 		return NULL;
 	}
 
-	if (*pattern)	{		/* got a string - make it the default */
+	if (*pattern) {		/* got a string - make it the default */
 		FreeIfNeeded(*def);
 		*def = my_strdup(pattern);
 	} else {
@@ -698,7 +865,17 @@ prompt_msgid(
 		 * If the article is no longer part of a thread, then there is
 		 * no way to display it
 		 */
-		if (which_thread(msgid->article) == -1) {
+		/*
+		 * TODO: Find a better solution, as we end up in the select
+		 *       level after leaving the thread or page level with
+		 *       show_only_unread_arts = TRUE.
+		 *
+		 *       Without !curr_group->attribute->show_only_unread_arts
+		 *       read articles are not found if
+		 *       show_only_unread_arts = TRUE.
+		 */
+		/* if (which_thread(msgid->article) == -1) { */
+		if (!curr_group->attribute->show_only_unread_arts && curr_group->attribute->thread_articles && which_thread(msgid->article) == -1) {
 			info_message(_(txt_no_last_message));
 			return ART_UNAVAILABLE;
 		}
@@ -821,7 +998,7 @@ prompt_slk_response(
 				case KEYMAP_PAGE_UP:
 				case KEYMAP_HOME:
 				case KEYMAP_END:
-					ch = '\0'; /* <- do not remove this! */
+					ch = '\0'; /* <- do not remove this! NOLINT(clang-analyzer-deadcode.DeadStores) */
 					func = NOT_ASSIGNED;
 					break;
 
@@ -866,7 +1043,7 @@ prompt_continue(
 	void)
 {
 	int ch;
-	int save_signal_context = signal_context;
+	enum context save_signal_context = signal_context;
 
 	cmd_line = TRUE;
 	info_message(_(txt_return_key));
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/read.c tin-2.6.5/src/read.c
--- tin-2.6.4/src/read.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/read.c	2025-11-13 02:21:32.584180169 +0100
@@ -3,9 +3,9 @@
  *  Module    : read.c
  *  Author    : Jason Faultless <jason@altarstone.com>
  *  Created   : 1997-04-10
- *  Updated   : 2024-04-10
+ *  Updated   : 2025-02-28
  *
- * Copyright (c) 1997-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 1997-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -89,19 +89,24 @@ wait_for_input(
 	forever {
 		FD_ZERO(&readfds);
 		FD_SET(STDIN_FILENO, &readfds);
-/*		FD_SET(fileno(NEED_REAL_NNTP_FD_HERE), &readfds); */
+/*		FD_SET(NEED_REAL_NNTP_FD_HERE, &readfds); */ /* nntp_buf.fd */
 
 		tv.tv_sec = 0;		/* NNTP_READ_TIMEOUT; */
 		tv.tv_usec = 0;
 
-/* DEBUG_IO((stderr, "waiting on %d and %d...", STDIN_FILENO, fileno(fd))); */
+/* DEBUG_IO((stderr, "%swaiting on %d and %d...\n", logtime(), STDIN_FILENO, fileno(fd))); */
 #	ifdef HAVE_SELECT_INTP
 		if ((nfds = select(STDIN_FILENO + 1, (int *) &readfds, NULL, NULL, &tv)) == -1)
 #	else
 		if ((nfds = select(STDIN_FILENO + 1, &readfds, NULL, NULL, &tv)) == -1)
 #	endif /* HAVE_SELECT_INTP */
 		{
-			if (errno != EINTR) {
+#	ifdef EINTR
+			if (errno != EINTR)
+#	else
+			if (errno != 0)
+#	endif /* EINTR */
+			{
 				perror_message("select() failed");
 				free(tin_progname);
 				giveup();
@@ -158,7 +163,7 @@ wait_for_input(
 			/*
 			 * Our file has something for us to read
 			 */
-			if (FD_ISSET(fileno(NEED_NNTP_FD_HERE), &readfds))
+			if (FD_ISSET(NEED_NNTP_FD_HERE, &readfds))	/* nntp_buf.fd */
 				return TRUE;
 #	endif /* 0 */
 		}
@@ -355,7 +360,7 @@ tin_fgets(
 		return NULL;
 
 	if (tin_errno != 0) {
-		DEBUG_IO((stderr, _("Aborted read\n")));
+		DEBUG_IO((stderr, "%sAborted read\n", logtime()));
 		return NULL;
 	}
 
@@ -381,16 +386,16 @@ tin_fgets(
 	if (fp == FAKE_NNTP_FP) {
 		if (dynbuf[0] == '.') {			/* reduce leading .'s */
 			if (dynbuf[1] == '\0') {
-				DEBUG_IO((stderr, "tin_fgets(NULL)\n"));
+				DEBUG_IO((stderr, "%stin_fgets(NULL)\n", logtime()));
 				return NULL;
 			}
-			DEBUG_IO((stderr, "tin_fgets(%s)\n", dynbuf + 1));
+			DEBUG_IO((stderr, "%stin_fgets(\"%s\")\n", logtime(), dynbuf + 1));
 			return (dynbuf + 1);
 		}
 	}
 #endif /* NNTP_ABLE */
 
-DEBUG_IO((stderr, "tin_fgets(%s)\n", (dynbuf) ? dynbuf : "NULL"));
+	DEBUG_IO((stderr, "%stin_fgets(\"%s\")\n", logtime(), dynbuf ? dynbuf : "NULL"));
 
 	return dynbuf;
 }
@@ -410,7 +415,7 @@ drain_buffer(
 	if (fp != FAKE_NNTP_FP)
 		return;
 
-DEBUG_IO((stderr, _("Draining\n")));
+	DEBUG_IO((stderr, "%sDraining\n", logtime()));
 	while (tin_fgets(fp, FALSE) != NULL) {
 		if (++i % MODULO_COUNT_NUM == 0)
 			spin_cursor();
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/refs.c tin-2.6.5/src/refs.c
--- tin-2.6.4/src/refs.c	2024-12-04 18:05:57.000000000 +0100
+++ tin-2.6.5/src/refs.c	2025-11-13 02:21:32.588180344 +0100
@@ -3,12 +3,12 @@
  *  Module    : refs.c
  *  Author    : Jason Faultless <jason@altarstone.com>
  *  Created   : 1996-05-09
- *  Updated   : 2024-12-04
+ *  Updated   : 2025-11-06
  *  Notes     : Caching of message ids / References based threading
  *  Credits   : Richard Hodson <richard@macgyver.tele2.co.uk>
  *              hash_msgid, free_msgid
  *
- * Copyright (c) 1996-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 1996-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -651,7 +651,7 @@ dump_thread(
 	if (msgid->article >= 0)
 		sprintf(ptr + len, "%-*.*s   %-17.17s", i, i, arts[msgid->article].subject, (arts[msgid->article].mailbox->name) ? arts[msgid->article].mailbox->name : arts[msgid->article].mailbox->from);
 	else
-		sprintf(ptr + len, "%-*.*s", i, i, _("[- Unavailable -]"));
+		sprintf(ptr + len, "%-*.*s", i, i, "[- Unavailable -]");
 
 	fprintf(fp, "%s\n", ptr);
 
@@ -1019,20 +1019,14 @@ collate_subjects(
  */
 void
 build_references(
-	const struct t_group *group)
+	void)
 {
 	static char msg[LEN];
-	char *s;
+	char *s, *ptr;
 	int i;
 	struct t_article *art;
 	struct t_msgid *refs;
 
-	/*
-	 * The articles are currently unsorted, and are as they were put by setup_hard_base()
-	 */
-	if (group->attribute && group->attribute->sort_article_type != SORT_ARTICLES_BY_NOTHING)
-		sort_arts(group->attribute->sort_article_type);
-
 #ifdef DEBUG
 	if (debug & DEBUG_REFS) {
 		char file[PATH_LEN];
@@ -1067,8 +1061,6 @@ build_references(
 			 * TODO: do this in a single pass
 			 */
 			if ((s = strrchr(art->refs, '<')) != NULL) {
-				char *ptr;
-
 				/*
 				 * A comment can occur after another REF_SEP, remove it
 				 *
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/regex.c tin-2.6.5/src/regex.c
--- tin-2.6.4/src/regex.c	2024-12-03 03:56:20.000000000 +0100
+++ tin-2.6.5/src/regex.c	2025-11-13 02:21:32.596180693 +0100
@@ -3,11 +3,11 @@
  *  Module    : regex.c
  *  Author    : Jason Faultless <jason@altarstone.com>
  *  Created   : 1997-02-21
- *  Updated   : 2024-12-03
+ *  Updated   : 2025-07-09
  *  Notes     : Regular expression subroutines
  *  Credits   :
  *
- * Copyright (c) 1997-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 1997-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -170,12 +170,15 @@ compile_regex(
 	struct regex_cache *cache,
 	REGEX_OPTIONS options)
 {
+	char curr_error[8192];
+	static char last_error[8192] = { '\0' };
+	t_bool different;
 #ifdef HAVE_LIB_PCRE2
 	int regex_errcode;
 	PCRE2_SIZE regex_errpos;
 
 	if (regex_use_utf8())
-		options |= PCRE2_UTF;
+		options |= PCRE2_UTF; /* TODO: add PCRE2_UCP? */
 
 	cache->re = pcre2_compile_8((const PCRE2_UCHAR8 *) regex, PCRE2_ZERO_TERMINATED, options,
 			&regex_errcode, &regex_errpos, NULL);
@@ -183,7 +186,11 @@ compile_regex(
 		PCRE2_UCHAR8 regex_errmsg[256];
 
 		pcre2_get_error_message_8(regex_errcode, regex_errmsg, sizeof(regex_errmsg));
-		error_message(2, _(txt_pcre_error_at), regex_errmsg, regex_errpos, regex);
+		snprintf(curr_error, sizeof(curr_error), _(txt_pcre_error_at), regex_errmsg, regex_errpos, regex);
+		different = (strcmp(last_error, curr_error) != 0);
+		error_message(different ? 2 : 0, "%s", curr_error);
+		if (different)
+			strcpy(last_error, curr_error);
 	} else {
 		cache->match = pcre2_match_data_create_from_pattern_8(cache->re, NULL);
 		if (cache->match == NULL) /* out of memory ... */
@@ -201,9 +208,13 @@ compile_regex(
 	if (regex_use_utf8())
 		options |= PCRE_UTF8;
 
-	if ((cache->re = pcre_compile(regex, options, &regex_errmsg, &regex_errpos, NULL)) == NULL)
-		error_message(2, _(txt_pcre_error_at), regex_errmsg, regex_errpos, regex);
-	else {
+	if ((cache->re = pcre_compile(regex, options, &regex_errmsg, &regex_errpos, NULL)) == NULL) {
+		snprintf(curr_error, sizeof(curr_error), _(txt_pcre_error_at), regex_errmsg, regex_errpos, regex);
+		different = (strcmp(last_error, curr_error) != 0);
+		error_message(different ? 2 : 0, "%s", curr_error);
+		if (different)
+			strcpy(last_error, curr_error);
+	} else {
 		cache->extra = pcre_study(cache->re, 0, &regex_errmsg);
 		if (regex_errmsg != NULL) {
 			/* we failed, clean up */
@@ -287,11 +298,10 @@ void
 regex_cache_init(
 	struct regex_cache *regex)
 {
-#ifdef HAVE_LIB_PCRE2
 	regex->re = NULL;
+#ifdef HAVE_LIB_PCRE2
 	regex->match = NULL;
 #else
-	regex->re = NULL;
 	regex->extra = NULL;
 	regex->ovector = NULL;
 	regex->ovecalloc = 0;
@@ -320,6 +330,52 @@ regex_cache_destroy(
 #endif /* HAVE_LIB_PCRE2 */
 }
 
+
+/*
+ * returns freshly allocated mem which holds the matched portion
+ * of the named subpattern on success and NULL on error
+ */
+char *
+regex_get_substring_by_name(
+	struct regex_cache *re,		/* precompiled regex */
+	const char *sname,			/* name of subpattern */
+	char *subject)				/* data to match against */
+{
+	char *ms;
+	int snum;
+
+#ifdef HAVE_LIB_PCRE2
+	PCRE2_UCHAR8 *buf = NULL;
+	PCRE2_SIZE buflen = 0;
+
+	(void) subject;
+	if ((snum = pcre2_substring_number_from_name_8(re->re, (PCRE2_SPTR8) sname)) < 1)
+		return NULL;
+
+	if (pcre2_substring_get_bynumber_8(re->match, snum, &buf, &buflen) < 0) {
+		pcre2_substring_free_8(buf);
+		return NULL;
+	}
+	ms = my_strdup((const char *) buf);
+	pcre2_substring_free_8(buf);
+	return ms;
+
+#else
+	const char *buf = NULL;
+
+	regex_get_ovector_pointer(re);
+	if ((snum = pcre_get_stringnumber(re->re, sname)) < 1)
+		return NULL;
+
+	if (pcre_get_substring(subject, re->ovector, re->oveccount, snum, &buf) < 1)
+		return NULL;
+
+	ms = my_strdup(buf);
+	pcre_free_substring(buf);
+	return ms;
+#endif /* HAVE_LIB_PCRE2 */
+}
+
 
 t_bool
 regex_use_utf8(
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/rfc1524.c tin-2.6.5/src/rfc1524.c
--- tin-2.6.4/src/rfc1524.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/rfc1524.c	2025-11-13 02:21:32.600180867 +0100
@@ -3,10 +3,10 @@
  *  Module    : rfc1524.c
  *  Author    : Urs Janssen <urs@tin.org>, Jason Faultless <jason@altarstone.com>
  *  Created   : 2000-05-15
- *  Updated   : 2024-11-25
+ *  Updated   : 2025-01-30
  *  Notes     : mailcap parsing as defined in RFC 1524
  *
- * Copyright (c) 2000-2025 Urs Janssen <urs@tin.org>, Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 2000-2026 Urs Janssen <urs@tin.org>, Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,9 +51,9 @@
 #define MAILCAPFIELDS 13
 
 /* local prototypes */
-static char *expand_mailcap_meta(const char *mailcap, t_part *part, t_bool escape_shell_meta_chars, const char *path);
+static char *expand_mailcap_meta(const char *mailcap, const t_part *part, t_bool escape_shell_meta_chars, const char *path);
 static char *get_mailcap_field(char *mailcap);
-static t_mailcap *parse_mailcap_line(const char *mailcap, t_part *part, const char *path);
+static t_mailcap *parse_mailcap_line(const char *mailcap, const t_part *part, const char *path);
 
 
 /*
@@ -65,7 +65,7 @@ static t_mailcap *parse_mailcap_line(con
  */
 t_mailcap *
 get_mailcap_entry(
-	t_part *part,
+	const t_part *part,
 	const char *path)
 {
 	FILE *fp;
@@ -157,7 +157,7 @@ get_mailcap_entry(
 static t_mailcap*
 parse_mailcap_line(
 	const char *mailcap,
-	t_part *part,
+	const t_part *part,
 	const char *path)
 {
 	char *ptr, *optr, *buf;
@@ -213,6 +213,7 @@ parse_mailcap_line(
 			ptr += strlen(ptr) + 1;
 		}
 		if (!strncasecmp(ptr, "nametemplate=", 13)) {
+			FreeIfNeeded(tmailcap->nametemplate);
 			tmailcap->nametemplate = expand_mailcap_meta(ptr + 13, part, FALSE, path);
 			ptr += strlen(ptr) + 1;
 		}
@@ -349,13 +350,13 @@ get_mailcap_field(
 static char *
 expand_mailcap_meta(
 	const char *mailcap,
-	t_part *part,
+	const t_part *part,
 	t_bool escape_shell_meta_chars,
 	const char *path)
 {
 	const char *ptr;
 	char *line, *lptr;
-	int quote = no_quote;
+	enum quote_enum quote = no_quote;
 	size_t linelen, space, olen;
 
 	if (!(strchr(mailcap, '%'))) /* nothing to expand */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/rfc2045.c tin-2.6.5/src/rfc2045.c
--- tin-2.6.4/src/rfc2045.c	2024-12-05 22:23:38.000000000 +0100
+++ tin-2.6.5/src/rfc2045.c	2025-11-13 02:21:32.608181216 +0100
@@ -3,10 +3,10 @@
  *  Module    : rfc2045.c
  *  Author    : Chris Blum <chris@resolution.de>
  *  Created   : 1995-09-01
- *  Updated   : 2023-12-05
+ *  Updated   : 2025-09-03
  *  Notes     : RFC 2045/2047 encoding
  *
- * Copyright (c) 1995-2025 Chris Blum <chris@resolution.de>
+ * Copyright (c) 1995-2026 Chris Blum <chris@resolution.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -82,7 +82,7 @@ rfc1521_encode(
 	static char buffer[80];
 	static int bits = 0;
 	static int xpos = 0;
-	static unsigned long pattern = 0;
+	static unsigned long pattern = 0L;
 
 	if (e == 'b') {
 		if (!b) {
@@ -108,7 +108,7 @@ rfc1521_encode(
 						*b++ = '=';
 					++xpos;
 				}
-				pattern = 0;
+				pattern = 0L;
 				bits = 0;
 			}
 			if (xpos) {
@@ -120,19 +120,19 @@ rfc1521_encode(
 		} else {
 			char *line_crlf = line;
 			size_t len = strlen(line);
-			char tmpbuf[2050]; /* FIXME: we don't do VLAs, so this is sizeof(buffer)+2 from rfc15211522_encode() */
+			char *tmpbuf = NULL;
 
 			/*
 			 * base64 requires CRLF line endings in text types
 			 * convert LF to CRLF if not CRLF already (Windows?)
 			 */
-			if ((len > 0) && (line[len - 1] == '\n') &&
-					((len == 1) || (line[len - 2] != '\r'))) {
-				STRCPY(tmpbuf, line);
-				line_crlf = tmpbuf;
-				line_crlf[len - 1] = '\r';
-				line_crlf[len] = '\n';
-				line_crlf[len + 1] = '\0';
+			if (len < 2 || line[len - 2] != '\r' || line[len - 1] != '\n') {
+				tmpbuf = my_strdup(line);
+				if (len && line[len - 1] == '\n')
+					tmpbuf[--len] = '\0';
+				if (len && line[len - 1] == '\r')
+					tmpbuf[--len] = '\0';
+				line_crlf = tmpbuf = append_to_string(tmpbuf, "\r\n");
 			}
 
 			while (*line_crlf) {
@@ -152,9 +152,10 @@ rfc1521_encode(
 						++xpos;
 						bits -= 6;
 					}
-					pattern = 0;
+					pattern = 0L;
 				}
 			}
+			FreeIfNeeded(tmpbuf);
 		}
 	} else if (e == 'q') {
 		char *l;
@@ -213,7 +214,7 @@ rfc1521_encode(
 		*b = '\0';
 		if (b != buffer)
 			fputs(buffer, f);
-		if (b != buffer && b[-1] == '\n')
+		if (b != buffer && *(b - 1) == '\n')
 			xpos = 0;
 	} else if (line)
 		fputs(line, f);
@@ -231,7 +232,7 @@ set_rest(
 {
 	char *old_rest = *rest;
 
-	if (ptr == NULL || strlen(ptr) == 0) {
+	if (ptr == NULL || !*ptr) {
 		FreeAndNull(*rest);
 		return;
 	}
@@ -265,7 +266,7 @@ put_rest(
 
 	if ((ptr = my_rest) == NULL)
 		return put_chars;
-	if (strlen(my_rest) == 0) {
+	if (!*my_rest) {
 		FreeAndNull(*rest);
 		return put_chars;
 	}
@@ -281,7 +282,7 @@ put_rest(
 				*max_line_len = LEN;
 			else
 				*max_line_len <<= 1;
-			*line = my_realloc(*line, *max_line_len);
+			*line = my_realloc(*line, *max_line_len + 1);
 		}
 		(*line)[put_chars++] = c;
 	}
@@ -354,7 +355,7 @@ read_decoded_base64_line(
 	 */
 	if (*max_line_len == 0) {
 		*max_line_len = LEN;
-		*line = my_malloc(*max_line_len);
+		*line = my_malloc(*max_line_len + 1);
 	}
 
 	/*
@@ -388,7 +389,7 @@ read_decoded_base64_line(
 			 */
 			if (put_chars > (int) *max_line_len - 2) {
 				*max_line_len <<= 1;
-				*line = my_realloc(*line, *max_line_len);
+				*line = my_realloc(*line, *max_line_len + 1);
 			}
 			(*line)[put_chars++] = '\n';
 			(*line)[put_chars] = '\0';
@@ -412,10 +413,10 @@ read_decoded_base64_line(
 	 */
 	if (put_chars > (int) *max_line_len - 2) {
 		*max_line_len <<= 1;
-		*line = my_realloc(*line, *max_line_len);
+		*line = my_realloc(*line, *max_line_len + 1);
 	}
 	if ((put_chars == 0) || ((*line)[put_chars - 1] != '\n'))
-			(*line)[put_chars++] = '\n';
+		(*line)[put_chars++] = '\n';
 	(*line)[put_chars] = '\0';
 	return lines_read;
 }
@@ -519,12 +520,14 @@ read_decoded_qp_line(
 	} else	/* error in encoding: copy raw line */
 		ptr = buf;
 
-	if (*max_line_len < strlen(ptr) + 1) {
-		*max_line_len = strlen(ptr) + 1;
-		*line = my_realloc(*line, *max_line_len);
+	if (*max_line_len <= strlen(ptr)) {
+		free(*line);
+		*line = my_strdup(ptr);
+		*max_line_len = strlen(*line);
+	} else {
+		strncpy(*line, ptr, *max_line_len);
+		(*line)[*max_line_len - 1] = '\0'; /* be sure to terminate string */
 	}
-	strncpy(*line, ptr, *max_line_len);
-	(*line)[*max_line_len - 1] = '\0'; /* be sure to terminate string */
 	free(buf);
 	free(buf2);
 	return lines_read;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/rfc2046.c tin-2.6.5/src/rfc2046.c
--- tin-2.6.4/src/rfc2046.c	2024-12-21 03:49:14.000000000 +0100
+++ tin-2.6.5/src/rfc2046.c	2025-12-23 02:59:31.857972700 +0100
@@ -3,10 +3,10 @@
  *  Module    : rfc2046.c
  *  Author    : Jason Faultless <jason@altarstone.com>
  *  Created   : 2000-02-18
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-23
  *  Notes     : RFC 2046 MIME article parsing
  *
- * Copyright (c) 2000-2025 Jason Faultless <jason@altarstone.com>
+ * Copyright (c) 2000-2026 Jason Faultless <jason@altarstone.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -412,7 +412,7 @@ decode_value(
 
 	while (*rptr) {
 		if (*rptr == '%' && IS_XDIGIT(*(rptr + 1)) && IS_XDIGIT(*(rptr + 2))) {
-			*wptr++ = (char) (XVAL(*(rptr + 1)) << 4 | XVAL(*(rptr + 2)));
+			*wptr++ = (char) ((XVAL(*(rptr + 1)) << 4) | XVAL(*(rptr + 2)));
 			rptr += 3;
 		} else
 			*wptr++ = *rptr++;
@@ -526,6 +526,15 @@ parse_params(
 		ptr = new_params();
 		ptr->name = name;
 		if (encoded) {
+			/*
+			 * RFC 6266 defines 'filename' and 'filename*' which may
+			 * occur simultaneously. Restore 'filename*' if '*' was
+			 * present.
+			 */
+			if (!strcmp(ptr->name, "filename")) {
+				free(ptr->name);
+				ptr->name = my_strdup("filename*");
+			}
 			ptr->encoded = TRUE;
 			ptr->charset = get_charset(value);
 			ptr->value = strip_charset(&value);
@@ -980,6 +989,11 @@ new_part(
 	ptr->line_count = 0;
 	ptr->bytes = 0;
 	ptr->depth = 0;							/* Not an embedded object (yet) */
+	ptr->yenc_part = 0;						/* current yenc part */
+	ptr->yenc_total = 0;					/* total # of yenc parts */
+	ptr->yenc_part_size = 0;				/* total size of yenc */
+	ptr->yenc_total_size = 0;				/* size of current yenc part */
+	ptr->yenc_crc = 0;						/* yenc checksum */
 	ptr->mime_hints.flags = MIME_INIT;
 	ptr->mime_hints.type = my_strdup("None");
 	ptr->mime_hints.subtype = my_strdup("None");
@@ -1188,7 +1202,7 @@ quote_display_name(
 		*to++ = '"';
 		while (*ptr) {
 			/*
-			 * RFC 5322 §3.2.1
+			 * RFC 5322 3.2.1
 			 * quoted-pair = ("\" (VCHAR / WSP))
 			 *
 			 * RFC 5234
@@ -1505,9 +1519,10 @@ count_lines(
 	char c;
 	int lines = 1;
 
-	while ((c = *src++))
+	while ((c = *src++)) {
 		if (c == '\n')
 			++lines;
+	}
 	return lines;
 }
 
@@ -2059,13 +2074,15 @@ art_open(
 	 *       build_references().
 	 */
 
-	if ((artinfo->tex2iso = ((group->attribute->tex2iso_conv) ? is_art_tex_encoded(artinfo->raw) : FALSE)))
-		wait_message(0, _(txt_is_tex_encoded));
-
 	/* Maybe fix it so if this fails, we default to raw? */
-	if (!cook_article(wrap_lines, artinfo, tinrc.hide_uue, FALSE))
+	if (!cook_article(wrap_lines, artinfo, group->attribute->hide_inline_data, FALSE))
 		return ART_ABORT;
 
+#if 0 /* ok for single arts but if art_open() is called in a loop (e.g. body_search()) */
+	if (artinfo->tex2iso && group->attribute->tex2iso_conv)
+		wait_message(0, _(txt_is_tex_encoded));
+#endif /* 0 */
+
 	log_article_info(artinfo);
 
 #ifdef DEBUG_ART
